#!/bin/sh

if [ ! -n "$1" ]
then
    echo "--------------------------------------------------------------"
    echo ""
    echo "  Usage: `basename $0` <intallation dir>"
    echo ""
    echo "  where <installation dir> is the full path to the location of"
    echo "  h2o directory under the tomcat webapps directory. "
    echo "  Note: java must be in your path"
    echo ""
    echo "  EXAMPLE:"
    echo "  create-search-index.sh /opt/jakarta-tomcat-4.1.18/webapps/h2o"
    echo ""
    echo "--------------------------------------------------------------"
    exit $E_BADARGS
fi

add_to_classpath () {
    dir=$1 
    for x in `find $dir -name '*.jar' -print`; do
        CLASSPATH=$x:$CLASSPATH;
    done
}

INSTALL_DIR=$1

if [ -n "$2" ]
then
    # set up CLASSPATH for local berkman install 
    CLASSPATH=$INSTALL_DIR/webapp/WEB-INF/classes
    add_to_classpath "$INSTALL_DIR/webapp/WEB-INF/lib" 
    add_to_classpath "$INSTALL_DIR/tomcat/common/lib" 
else 
    # set up CLASSPATH for war file deployment
    CLASSPATH=$INSTALL_DIR/WEB-INF/classes
    add_to_classpath "$INSTALL_DIR/WEB-INF/lib" 
    add_to_classpath "$INSTALL_DIR/../../common/lib" 
fi

cd $INSTALL_DIR
java -classpath "$CLASSPATH" \
     edu.harvard.law.cyber.h2o.util.search.H2OStandaloneIndexBuilder
