/* $Id: projects.sql,v 1.21 2004/01/28 01:37:46 hroberts Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table projects(
       projects_id                      int primary key,
       name                             varchar(128) not null,
       lower_name                       varchar(128) not null,
       start_date                       bigint not null,
       owner_users_id                   int not null, /* references users */
       end_date                         bigint,
       registration_deadline            bigint,
       affiliation                      varchar(128),
       keywords                         varchar(256),
       description                      text,
       board_visibility                 int not null,
       rotisserie_visibility            int not null,
       project_registration             int,
       rotisserie_invitation_policy     int,
       use_boards                       boolean default 't' not null,
       system_show                      boolean DEFAULT TRUE,
       license                          varchar(128) not null,
       default_file_license             varchar(128)
);

create sequence projects_seq;
alter table projects alter projects_id set default nextval('projects_seq');


create unique index projects_name 
       on projects(lower_name, owner_users_id, start_date);
create index projects_start_date 
       on projects(start_date);
create index projects_owner_users_id 
       on projects(owner_users_id);
create index projects_registration_deadline 
       on projects(registration_deadline);

create trigger projects_lower_name
       before insert or update on projects for each row
       execute procedure copy_lower_name();       
create trigger update_project_name
       before update on projects for each row
       execute procedure update_project_name();

