/* $Id: requests.sql,v 1.12 2003/08/21 17:03:45 jarmstrong Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table requests(
       requests_id                       int primary key,
       issuer_users_id		             int not null,
       joiner_users_id     	             int,
       joiner_projects_id  	             int,
       activity_projects_id              int,
       activity_rotisseries_id           int,
       activity_board_thread_id          int,
       position			                 int not null,
       type             	             int not null,
       status                            int not null,
       last_updated                      bigint not null,
       message                           text,
       constraint requests_joiner check
                  (((joiner_users_id is null) and
                    (joiner_projects_id is not null)) or
                   ((joiner_users_id is not null) and
                    (joiner_projects_id is null))),
       constraint requests_activity check
                  (((activity_projects_id is null) and 
                    (activity_board_thread_id is null) and 
                    (activity_rotisseries_id is not null)) or
                   ((activity_projects_id is not null) and
                    (activity_board_thread_id is null) and 
                    (activity_rotisseries_id is null)) or
                   ((activity_projects_id is null) and
                    (activity_board_thread_id is not null) and 
                    (activity_rotisseries_id is null)))
);

create sequence requests_seq;
alter table requests alter requests_id set default nextval('requests_seq');

create unique index requests_unique
       on requests(joiner_users_id, joiner_projects_id, activity_projects_id,
            activity_rotisseries_id, activity_board_thread_id, 
            position, status);

create index requests_issuer_user on requests(issuer_users_id);
create index requests_joiner_proj on requests(joiner_projects_id);
create index requests_activity_project on requests(activity_projects_id);
create index requests_activity_rotisserie on requests(activity_rotisseries_id);
create index requests_activity_board_thread on requests(activity_board_thread_id);
create index requests_type on requests(type);
create index requests_status on requests(status);
create index requests_last_updated on requests(last_updated);
