/* $Id: topics.sql,v 1.4 2002/03/06 13:24:37 hroberts Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table topics(
       topics_id                int primary key,
       name                     varchar(128) not null,
       lower_name               varchar(128) not null,
       start_date               bigint not null,
       projects_id              int not null,
       end_date                 bigint,
       description              text
);

create sequence topics_seq;
alter table topics alter topics_id set default nextval('topics_seq');


create unique index topics_name on topics(lower_name, projects_id);
create index topics_start_date on topics(start_date);
create index topics_projects_id on topics(projects_id);

create trigger topics_lower_name
       before insert or update on topics for each row
       execute procedure copy_lower_name();       
