/* $Id: users.sql,v 1.17 2004/01/28 01:37:46 hroberts Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table users(
       users_id                 int primary key,
       name                     varchar(128) not null,
       lower_name               varchar(128) not null, 
       md5_password             varchar(128) not null,
       registration_date        bigint not null,
       is_site_administrator    boolean not null,
       timezone			varchar(128) not null,
       email                    varchar(128),
       first_name               varchar(128),
       lower_first_name         varchar(128),
       last_name                varchar(128),
       lower_last_name          varchar(128),
       confirmation_key         varchar(16),
       rotisserie_action_alert  boolean,
       post_response_alert      boolean,
       real_name_visibility     int,
       biography                text,
       city			varchar(128),
       country			varchar(128),
       affiliation		varchar(128),
       homepage			text,
       internet_memory		text,
       recent_book		text,
       invitation_alert         boolean,
       namespace_projects_id    int,
       namespace_projects_name  varchar(128)
);

create sequence users_seq;
alter table users alter users_id set default nextval('users_seq');

create index users_name on users(lower_name, namespace_projects_id);
create index users_md5_password on users(md5_password);
create index users_registration_date on users(registration_date);
create index users_is_site_administrator on users(is_site_administrator);
create index users_last_name on users(last_name);
create index users_first_name on users(first_name);
create index users_lower_last_name on users(lower(last_name));
create index users_lower_first_name on users(lower(first_name));
create index users_confirmation_key on users(confirmation_key);

create trigger users_lower_name
       before insert or update on users for each row
       execute procedure copy_lower_name();
create trigger users_lower_first_name
       before insert or update on users for each row
       execute procedure copy_lower_first_name();
create trigger users_lower_last_name
       before insert or update on users for each row
       execute procedure copy_lower_last_name();

create trigger insert_user_project_name
       before insert on users for each row
       execute procedure insert_user_project_name();
create trigger update_user_project_name
       before update on users for each row
       execute procedure update_user_project_name();

create trigger check_user_name_unique
       before insert or update on users for each row
       execute procedure check_user_name_unique();

