/* $Id: functions.pre.sql,v 1.5 2002/03/20 18:55:31 hroberts Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

/* postgresql magic to setup the plpgsql stuff */
create or replace function plpgsql_call_handler () 
       returns opaque as '/usr/lib/pgsql/plpgsql.so' language 'C';
create TRUSTED procedural language 'plpgsql' 
       handler plpgsql_call_handler lancompiler 'PL/pgSQL';

create or replace function copy_lower_name()
       returns opaque
       as '
       BEGIN 
             new.lower_name = lower(new.name); 
             return new; 
       END;'
       language 'plpgsql';

create or replace function copy_lower_first_name()
       returns opaque
       as '
       BEGIN 
             new.lower_first_name = lower(new.first_name); 
             return new; 
       END;'
       language 'plpgsql';

create or replace function copy_lower_last_name()
       returns opaque
       as '
       BEGIN 
             new.lower_last_name = lower(new.last_name); 
             return new; 
       END;'
       language 'plpgsql';

create or replace function raise_exception()
       returns opaque
       as '
       BEGIN 
             raise exception ''abort'';
             return null;
       END;'
       language 'plpgsql';

create or replace function addbigint(bigint, bigint) 
       returns bigint 
       as '
       BEGIN 
             return $1 + $2; 
       END;' 
       language plpgsql
       with (iscachable);
