/* $Id: assignments.sql,v 1.7 2003/02/12 20:12:54 jmarinus Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table assignments(
       assignments_id   int primary key,
       rotisseries_id   int not null,
       rounds_id        int,
       posts_id         int,
       users_id         int not null,
       /* 1 = response, 2 = rating, 3 = initial response, 4 = final rating, 5 = poll */
       type		int not null,
       submitted_date	bigint,
       constraint assignments_post
                  check ((((type = 3) or (type = 5)) and (posts_id is null)) or
                         (posts_id is not null)),
       constraint assignments_round
                  check (((type = 4) and (rounds_id is null)) or
                         ((type <> 4) and (rounds_id is not null)))
);

create sequence assignments_seq;
alter table assignments alter assignments_id
      set default nextval('assignments_seq');

create unique index assignments_unique 
       on assignments(rounds_id, posts_id, users_id, type);
create index assignments_posts_id
       on assignments(posts_id);
create index assignments_users_id
       on assignments(users_id);
create index assignments_type
       on assignments(type);
create index assignments_submitted_date
       on assignments(submitted_date);

