/* $Id: posts.sql,v 1.11 2003/01/29 16:05:00 jarmstrong Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

/* If you change this table definition, you must also change the rules
   in threads_posts_map.post.sql.  Definitely don't change the rating 
   field without a full understanding of how the threaded_posts 
   denormlization works.
 */

create table posts(
       posts_id                 int primary key,
       users_id                 int not null,
       rounds_id                int not null,
       root_posts_id            int not null,
       parent_posts_id          int,
       title                    text not null,
       body                     text not null,
       submitted_date           bigint not null,
       rating                   int not null,
       self_rating              int,
       ad_hoc                   boolean default 'f' not null,
       thread_rating_total      int not null,
       thread_count             int not null
);

create sequence posts_seq;
alter table posts alter posts_id set default nextval('posts_seq');

create index posts_users_id on posts(users_id);
create index posts_parent_posts_id on posts(parent_posts_id);
create index posts_root_posts_id on posts(root_posts_id);
create index posts_rounds_id on posts(rounds_id);
create index posts_submitted_date on posts(submitted_date);
create index posts_rating on posts(rating);

