/* $Id: rotisseries.sql,v 1.13 2003/03/06 22:51:07 jarmstrong Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table rotisseries(
       rotisseries_id         int primary key,
       name                   varchar(128) not null,
       lower_name             varchar(128) not null,
       start_date             bigint not null,
       topics_id              int not null,
       use_ratings            boolean not null,
       use_comments           boolean default 't' not null,
       current_rounds_id      int,    
       expel_on_skip          boolean default 'f' not null,
       final_rating_routed    boolean not null,
       final_rating_date      bigint,
       completed              boolean
);

create sequence rotisseries_seq;
alter table rotisseries alter rotisseries_id set default nextval('rotisseries_seq');


create unique index rotisseries_unique
       on rotisseries(topics_id, lower_name);
create index rotisseries_name
       on rotisseries(lower_name);
create index rotisseries_final_rating_routed
       on rotisseries(final_rating_routed);
create index rotisseries_final_rating_date
       on rotisseries(final_rating_date);
create index rotisseries_completed
       on rotisseries(completed);

create trigger rotisseries_lower_name
       before insert or update on rotisseries for each row
       execute procedure copy_lower_name();       
