/* $Id: rounds.sql,v 1.14 2003/01/17 21:27:02 jmarinus Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

create table rounds(
       rounds_id                int primary key,
       rotisseries_id           int not null,
       round_order              int not null,
       route_date		bigint,
       send_date		bigint,
       due_date			bigint not null,
       collect_date		bigint,
       use_grace_period         boolean default 't' not null,
       routing_method           int,
       maximum_post_length      int,
       minimum_post_length      int,
       question                 text,
       last_alert_date          bigint,
       routed                   boolean not null,
       sent                     boolean not null
);

create sequence rounds_seq;
alter table rounds alter rounds_id set default nextval('rounds_seq');

create unique index rounds_unique on rounds(rotisseries_id, round_order);
create index rounds_round_order on rounds(round_order);
create index rounds_route_date on rounds(route_date);
create index rounds_send_date on rounds(send_date);
create index rounds_due_date on rounds(due_date);
create index rounds_routed on rounds(routed);
create index rounds_sent on rounds(sent);
create index rounds_collect_date on rounds(collect_date);
create index rounds_last_alert_date on rounds(last_alert_date);
