
drop trigger rounds_initial_due_date on rounds;
drop trigger insert_round_duration on rounds;
drop trigger update_round_duration on rounds;
drop trigger delete_round_duration on rounds;

/* set duration field to not null */
update pg_attribute set attnotnull=FALSE
where attname='duration'
and attrelid=(select oid from pg_class where relname='rounds');

/* set grace period field to not null */
update pg_attribute set attnotnull=FALSE
where attname='grace_period'
and attrelid=(select oid from pg_class where relname='rounds');

alter table rounds 
      rename column duration to zzz_deleted_05_1;
alter table rounds 
      rename column grace_period to zzz_deleted_05_2;

alter table rounds add 
      column use_grace_period boolean;

update rounds 
       set use_grace_period = 't';

alter table rounds 
      add constraint rounds_use_grace_p_not_null 
      check (use_grace_period is not null);

alter table rounds 
      add constraint rounds_due_date_not_null 
      check (due_date is not null);
