/* $Id: functions.pre.sql,v 1.1 2003/09/03 01:11:43 hroberts Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */

/* postgresql magic to setup the plpgsql stuff */
create or replace function plpgsql_call_handler () 
       returns opaque as '/usr/lib/pgsql/plpgsql.so' language 'C';
create TRUSTED procedural language 'plpgsql' 
       handler plpgsql_call_handler lancompiler 'PL/pgSQL';

create or replace function requests_unique()
       returns opaque
       as '
       DECLARE 
           duplicate_requests int;
       BEGIN 
           if (new.status = 1) then
               select into duplicate_requests count(*) from requests
                      where requests_id <> new.requests_id and 
                            status = 1 and
                            position = new.position and
                            ((joiner_projects_id is null and 
                              new.joiner_projects_id is null) or
                             (joiner_projects_id = new.joiner_projects_id)) and
                            ((joiner_users_id is null and 
                              new.joiner_users_id is null) or
                             (joiner_users_id = new.joiner_users_id)) and
                            ((activity_projects_id is null and 
                              new.activity_projects_id is null) or
                             (activity_projects_id = 
                              new.activity_projects_id)) and
                            ((activity_rotisseries_id is null and 
                              new.activity_rotisseries_id is null) or
                             (activity_rotisseries_id = 
                              new.activity_rotisseries_id)) and
                            ((activity_board_thread_id is null and
                              new.activity_board_thread_id is null) or
                             (activity_board_thread_id = 
                              new.activity_board_thread_id));
               if (duplicate_requests > 0) then
                   raise exception ''Cannot insert a duplicate key into requests: requests_unique trigger check failed'';
               end if;
           end if;
           return new;
       END;'
       language 'plpgsql';

create or replace function populate_preferences()
        returns text 
        as '
        DECLARE
            row_data projects_users_participant_map%ROWTYPE;
        BEGIN
            FOR row_data IN SELECT DISTINCT * FROM 
                projects_users_participant_map LOOP
                INSERT INTO projects_users_preferences VALUES( 
                    nextval( ''projects_users_preferences_seq'' ),
                    row_data.projects_id, row_data.users_id, ''t'', ''t''); 
            END LOOP;
            RETURN ''complete!'';
        END; '
        language 'plpgsql';


create or replace function populate_discussion_visibility()
    returns text
    as '
    DECLARE
        row_data projects%ROWTYPE;
    BEGIN
        FOR row_data IN SELECT * FROM  projects LOOP
            IF ( row_data.project_visibility < 3 ) THEN 
                UPDATE projects 
                SET board_visibility = 1, rotisserie_visibility = 1
                WHERE projects_id = row_data.projects_id;
            ELSE
                UPDATE projects 
                SET board_visibility = 2, rotisserie_visibility = 2
                WHERE projects_id = row_data.projects_id;
            END IF;
        END LOOP;
        RETURN ''complete!'';
    END; '
    language 'plpgsql';
