/* $Id: functions.pre.sql,v 1.5 2004/01/28 16:48:38 jarmstrong Exp $
   Copyright 2002 Berkman Center for Internet & Society. All Rights Reserved.
 */
create or replace function insert_user_project_name()
       returns opaque
       as '
       DECLARE
           project_name varchar(128);
       BEGIN
           if (new.namespace_projects_id is not null) then
              select into project_name name from projects
                     where projects_id = new.namespace_projects_id;
              new.namespace_projects_name = project_name;
           end if;
           return new;
       END;'
       language 'plpgsql';

create or replace function update_user_project_name()
       returns opaque
       as '
       DECLARE
           project_name varchar(128);
       BEGIN
           if (new.namespace_projects_id is null) then
               new.namespace_projects_name = null;
           elsif ((old.namespace_projects_id is null) or (old.namespace_projects_id <> new.namespace_projects_id)) then
               select into project_name name from projects
                      where projects_id = new.namespace_projects_id;
               new.namespace_projects_name = project_name;
           end if;
           return new;
       END;'
       language 'plpgsql';

create or replace function update_project_name()
       returns opaque
       as '
       BEGIN
           if (new.name <> old.name) then
               update users set namespace_projects_name = new.name
                      where namespace_projects_id = new.projects_id;
           end if;
           return new;
       END;'
       language 'plpgsql';

create or replace function check_user_name_unique()
       returns opaque
       as '
       DECLARE
           duplicate_users int;
       BEGIN
           if (new.namespace_projects_id is null) then
               select into duplicate_users users_id from users
                      where lower_name = lower(new.name) and
                      users_id <> new.users_id and
                      namespace_projects_id is null;
           else 
               select into duplicate_users users_id from users
                      where lower_name = lower(new.name) and
                      users_id <> new.users_id and
                      namespace_projects_id = new.namespace_projects_id;
           end if;
           if (duplicate_users) then
               raise exception ''Cannot insert a duplicate key into requests: check_user_name_unique() trigger check failed'';
           end if;
           return new;
       END;'
       language 'plpgsql';
